﻿/*
Deployment script for DotNetNoteCom

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "DotNetNoteCom"
:setvar DefaultFilePrefix "DotNetNoteCom"
:setvar DefaultDataPath "F:\DATA\"
:setvar DefaultLogPath "F:\LOG\"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
PRINT N'Altering [dbo].[Notes]...';


GO
ALTER TABLE [dbo].[Notes]
    ADD [Num]          INT NULL,
        [UserId]       INT NULL,
        [CategoryId]   INT DEFAULT 0 NULL,
        [BoardId]      INT DEFAULT 0 NULL,
        [AplicationId] INT DEFAULT 0 NULL;


GO
PRINT N'Creating [dbo].[Blogs]...';


GO
CREATE TABLE [dbo].[Blogs] (
    [BlogId]      INT            IDENTITY (1, 1) NOT NULL,
    [Name]        NVARCHAR (50)  NOT NULL,
    [Url]         NVARCHAR (255) NULL,
    [Description] NVARCHAR (MAX) NULL,
    [BloggerName] NVARCHAR (50)  NULL,
    [DateCreated] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([BlogId] ASC)
);


GO
PRINT N'Creating [dbo].[Comments]...';


GO
CREATE TABLE [dbo].[Comments] (
    [Id] INT NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Courses]...';


GO
CREATE TABLE [dbo].[Courses] (
    [CourseId]   INT           IDENTITY (1, 1) NOT NULL,
    [CourseName] NVARCHAR (25) NOT NULL,
    PRIMARY KEY CLUSTERED ([CourseId] ASC)
);


GO
PRINT N'Creating [dbo].[Goods]...';


GO
CREATE TABLE [dbo].[Goods] (
    [GoodsId]          INT                IDENTITY (1, 1) NOT NULL,
    [GoodsName]        NVARCHAR (100)     NULL,
    [GoodsDescription] NVARCHAR (MAX)     NULL,
    [CreatedDate]      DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([GoodsId] ASC)
);


GO
PRINT N'Creating [dbo].[Logs]...';


GO
CREATE TABLE [dbo].[Logs] (
    [Id]              INT                IDENTITY (1, 1) NOT NULL,
    [Note]            NVARCHAR (MAX)     NULL,
    [Application]     NVARCHAR (50)      NULL,
    [Logger]          NVARCHAR (255)     NULL,
    [LogEvent]        NVARCHAR (MAX)     NULL,
    [Message]         NVARCHAR (MAX)     NULL,
    [MessageTemplate] NVARCHAR (MAX)     NULL,
    [Level]           NVARCHAR (128)     NULL,
    [TimeStamp]       DATETIMEOFFSET (7) NOT NULL,
    [Exception]       NVARCHAR (MAX)     NULL,
    [Properties]      XML                NULL,
    [Callsite]        NVARCHAR (MAX)     NULL,
    [IpAddress]       NVARCHAR (20)      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Posts]...';


GO
CREATE TABLE [dbo].[Posts] (
    [PostId]  INT            IDENTITY (1, 1) NOT NULL,
    [Title]   NVARCHAR (255) NOT NULL,
    [Content] NVARCHAR (MAX) NULL,
    [Created] DATETIME       NULL,
    [BlogId]  INT            NULL,
    PRIMARY KEY CLUSTERED ([PostId] ASC)
);


GO
PRINT N'Creating [dbo].[Signs]...';


GO
CREATE TABLE [dbo].[Signs] (
    [Id]       INT           IDENTITY (1, 1) NOT NULL,
    [UserId]   NVARCHAR (25) NOT NULL,
    [Password] NVARCHAR (20) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[SQLSessions]...';


GO
CREATE TABLE [dbo].[SQLSessions] (
    [Id]                         NVARCHAR (449)     NOT NULL,
    [Value]                      VARBINARY (MAX)    NOT NULL,
    [ExpiresAtTime]              DATETIMEOFFSET (7) NOT NULL,
    [SlidingExpirationInSeconds] BIGINT             NULL,
    [AbsoluteExpiration]         DATETIMEOFFSET (7) NULL,
    CONSTRAINT [pk_Id] PRIMARY KEY CLUSTERED ([Id] ASC) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY];


GO
PRINT N'Creating [dbo].[SQLSessions].[Index_ExpiresAtTime]...';


GO
CREATE NONCLUSTERED INDEX [Index_ExpiresAtTime]
    ON [dbo].[SQLSessions]([ExpiresAtTime] ASC);


GO
PRINT N'Creating [dbo].[SubTables]...';


GO
CREATE TABLE [dbo].[SubTables] (
    [Id]      INT            IDENTITY (1, 1) NOT NULL,
    [TableId] INT            NOT NULL,
    [Note]    NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Tables]...';


GO
CREATE TABLE [dbo].[Tables] (
    [Id]        INT            IDENTITY (1, 1) NOT NULL,
    [Note]      NVARCHAR (MAX) NULL,
    [TimeStamp] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating [dbo].[Tabs]...';


GO
CREATE TABLE [dbo].[Tabs] (
    [TabId]       INT            IDENTITY (1, 1) NOT NULL,
    [TabOrder]    INT            NOT NULL,
    [ParentId]    INT            NULL,
    [TabName]     NVARCHAR (100) NOT NULL,
    [TabPath]     NVARCHAR (255) NULL,
    [IsVisible]   BIT            NOT NULL,
    [CommunityId] INT            NULL,
    [IsBoard]     BIT            NOT NULL,
    [Target]      NVARCHAR (20)  NULL,
    [BoardAlias]  NVARCHAR (50)  NULL,
    PRIMARY KEY CLUSTERED ([TabId] ASC)
);


GO
PRINT N'Creating [dbo].[Warehouses]...';


GO
CREATE TABLE [dbo].[Warehouses] (
    [Id]          INT             IDENTITY (1, 1) NOT NULL,
    [Name]        NVARCHAR (200)  NULL,
    [Description] NVARCHAR (1000) NULL,
    [Address]     NVARCHAR (200)  NULL,
    [Phone]       NVARCHAR (20)   NULL,
    [Coordinate]  NVARCHAR (20)   NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'Creating unnamed constraint on [dbo].[Blogs]...';


GO
ALTER TABLE [dbo].[Blogs]
    ADD DEFAULT (GetDate()) FOR [DateCreated];


GO
PRINT N'Creating unnamed constraint on [dbo].[Goods]...';


GO
ALTER TABLE [dbo].[Goods]
    ADD DEFAULT (GetDate()) FOR [CreatedDate];


GO
PRINT N'Creating unnamed constraint on [dbo].[Posts]...';


GO
ALTER TABLE [dbo].[Posts]
    ADD DEFAULT GetDate() FOR [Created];


GO
PRINT N'Creating unnamed constraint on [dbo].[Posts]...';


GO
ALTER TABLE [dbo].[Posts]
    ADD DEFAULT (0) FOR [BlogId];


GO
PRINT N'Creating unnamed constraint on [dbo].[Tables]...';


GO
ALTER TABLE [dbo].[Tables]
    ADD DEFAULT (GetDate()) FOR [TimeStamp];


GO
PRINT N'Creating unnamed constraint on [dbo].[Tabs]...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (0) FOR [ParentId];


GO
PRINT N'Creating unnamed constraint on [dbo].[Tabs]...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (1) FOR [IsVisible];


GO
PRINT N'Creating unnamed constraint on [dbo].[Tabs]...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (0) FOR [CommunityId];


GO
PRINT N'Creating unnamed constraint on [dbo].[Tabs]...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (1) FOR [IsBoard];


GO
PRINT N'Creating unnamed constraint on [dbo].[Tabs]...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT ('_self') FOR [Target];


GO
PRINT N'Creating [dbo].[BlogPosts]...';


GO
CREATE VIEW [dbo].[BlogPosts]
AS 
    Select 
        b.Name, b.BloggerName, 
        p.Title, p.Content, p.Created
    From  
        Posts p Join Blogs b 
            On p.BlogId = b.BlogId
GO
PRINT N'Altering [dbo].[DeleteNote]...';


GO
--[7] 해당 글을 지우는 저장 프로시저(답변글이 있으면 업데이트하고 없으면 지운다.): DeleteNote, NotesDelete
ALTER Proc dbo.DeleteNote
    @Id Int,
    @Password NVarChar(255) -- 암호 매개변수 추가
As
    Declare @cnt Int
    Select @cnt = Count(*) From Notes
    Where Id = @Id And Password = @Password

    If @cnt = 0
    Begin
        Return 0 -- 번호와 암호가 맞는게 없으면 0을 반환
    End	

    Declare @AnswerNum Int
    Declare @RefOrder Int
    Declare @Ref Int
    Declare @ParentNum Int

    Select
        @AnswerNum = AnswerNum,     @RefOrder = RefOrder,
        @Ref = Ref,                 @ParentNum = ParentNum
    From Notes
    Where Id = @Id

    If @AnswerNum = 0
    Begin
        If @RefOrder > 0 
        Begin
            UPDATE Notes SET RefOrder = RefOrder - 1
            WHERE Ref = @Ref AND RefOrder > @RefOrder
            UPDATE Notes SET AnswerNum = AnswerNum - 1 WHERE Id = @ParentNum
        End
        Delete Notes Where Id = @Id
        Delete Notes 
        WHERE 
            Id = @ParentNum AND ModifyIp = N'((DELETED))' AND AnswerNum = 0	
    End
    Else
    Begin
        Update Notes 
        Set 
            Name = N'(Unknown)', Email = '', Password = '',
            Title = N'(삭제된 글입니다.)', 
            Content = N'(삭제된 글입니다. ' 
            + N'현재 답변이 포함되어 있기 때문에 내용만 삭제되었습니다.)',
            ModifyIp = N'((DELETED))', FileName = '', 
            FileSize = 0, CommentCount = 0
        Where Id = @Id  
    End
GO
PRINT N'Altering [dbo].[GetCountNotes]...';


GO
--[5] DotNetNote 테이블에 있는 레코드의 개수를 구하는 저장 프로시저: GetCountNotes, NotesCount
ALTER Proc dbo.GetCountNotes
As
    Select Count(*) From Notes
GO
PRINT N'Altering [dbo].[ListNotes]...';


GO
--[2] 게시판(DotNetNote)에서 데이터 출력: ListNotes
ALTER Procedure dbo.ListNotes
    @Page Int
As
    With DotNetNoteOrderedLists 
    As 
    (
        Select 
            [Id], [Name], [Email], [Title], [PostDate], [ReadCount], 
            [Ref], [Step], [RefOrder], [AnswerNum], [ParentNum], 
            [CommentCount], [FileName], [FileSize], [DownCount], 
            ROW_NUMBER() Over (Order By Ref Desc, RefOrder Asc) 
            As 'RowNumber' 
        From Notes
    ) 
    Select * From DotNetNoteOrderedLists 
    Where RowNumber Between @Page * 10 + 1 And (@Page + 1) * 10
GO
PRINT N'Altering [dbo].[ModifyNote]...';


GO
--[8] 해당 글을 수정하는 저장 프로시저: ModifyNote, NotesModify
ALTER Proc dbo.ModifyNote
    @Name       NVarChar(25), 
    @Email      NVarChar(100), 
    @Title      NVarChar(150), 
    @ModifyIp   NVarChar(15), 
    @Content    NText,
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @FileName	NVarChar(255),
    @FileSize	Int,

	@Category	NVarChar(50), -- 추가 
    
    @Id Int
As
    Declare @cnt Int

    Select @cnt = Count(*) From Notes 
    Where Id = @Id And Password = @Password

    If @cnt > 0 -- 번호와 암호가 맞는게 있다면...
    Begin
        Update Notes 
        Set 
            Name = @Name, Email = @Email, Title = @Title,
            ModifyIp = @ModifyIp, ModifyDate = GetDate(),
            Content = @Content, Encoding = @Encoding,
            Homepage = @Homepage, FileName = @FileName, FileSize = @FileSize
        Where Id = @Id

        Select '1'
    End
    Else
        Select '0'
GO
PRINT N'Altering [dbo].[ReplyNote]...';


GO
--[4] 게시판(DotNetNote)에 글을 답변: ReplyNote, NotesReply
ALTER Proc dbo.ReplyNote
    @Name       NVarChar(25), 
    @PostIp     NVarChar(15), 
    @Title      NVarChar(150), 
    @Content    NText, 
    @Category   NVarChar(10) = '', 

    @Email      NVarChar(100), 
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @ParentNum  Int,                    -- 부모글의 고유번호(Id)
    @FileName   NVarChar(255),
    @FileSize   Int
As
    --[0] 변수 선언
    Declare @MaxRefOrder Int
    Declare @MaxRefAnswerNum Int
    Declare @ParentRef Int
    Declare @ParentStep Int
    Declare @ParentRefOrder Int

    --[1] 부모글의 답변수(AnswerNum)를 1증가
    Update Notes Set AnswerNum = AnswerNum + 1 Where Id = @ParentNum 

    --[2] 같은 글에 대해서 답변을 두 번 이상하면 먼저 답변한 게 위에 나타나게 한다.
    Select @MaxRefOrder = RefOrder, @MaxRefAnswerNum = AnswerNum From Notes 
    Where 
        ParentNum = @ParentNum And 
        RefOrder = 
            (Select Max(RefOrder) From Notes Where ParentNum = @ParentNum)

    If @MaxRefOrder Is Null
    Begin
        Select @MaxRefOrder = RefOrder From Notes Where Id = @ParentNum
        Set @MaxRefAnswerNum = 0  
    End 

    --[3] 중간에 답변달 때(비집고 들어갈 자리 마련)
    Select 
        @ParentRef = Ref, @ParentStep = Step 
    From Notes Where Id = @ParentNum

    Update Notes 
    Set 
        RefOrder = RefOrder + 1 
    Where 
        Ref = @ParentRef And RefOrder > (@MaxRefOrder + @MaxRefAnswerNum)

    --[4] 최종저장
    Insert Notes
    (
        Name, Email, Title, PostIp, Content, Password, Encoding, 
        Homepage, Ref, Step, RefOrder, ParentNum, FileName, FileSize,
        Category
    )
    Values
    (
        @Name, @Email, @Title, @PostIp, @Content, @Password, @Encoding, 
        @Homepage, @ParentRef, @ParentStep + 1, 
        @MaxRefOrder + @MaxRefAnswerNum + 1, @ParentNum, @FileName, @FileSize,
        @Category
    )
GO
PRINT N'Altering [dbo].[SearchNoteCount]...';


GO
--[6] 검색 결과의 레코드 수 반환: SearchNoteCount, NotesSearchCount 
ALTER Proc dbo.SearchNoteCount
    @SearchField NVarChar(25),
    @SearchQuery NVarChar(25)
As
    Set @SearchQuery = '%' + @SearchQuery + '%'

    Select Count(*)
    From Notes
    Where
    (
        Case @SearchField 
            When 'Name' Then [Name]
            When 'Title' Then Title
            When 'Content' Then Content
            Else @SearchQuery
        End
    ) 
    Like 
    @SearchQuery
GO
PRINT N'Altering [dbo].[SearchNotes]...';


GO
--[9] 게시판(DotNetNote)에서 데이터 검색 리스트: SearchNotes, NotesSearchList 
ALTER Procedure dbo.SearchNotes
    @Page Int,
    @SearchField NVarChar(25),
    @SearchQuery NVarChar(25)
As
    With DotNetNoteOrderedLists 
    As 
    (
        Select 
            [Id], [Name], [Email], [Title], [PostDate], 
            [ReadCount], [Ref], [Step], [RefOrder], [AnswerNum], 
            [ParentNum], [CommentCount], [FileName], [FileSize], 
            [DownCount], 
            ROW_NUMBER() Over (Order By Ref Desc, RefOrder Asc) 
            As 'RowNumber' 
        From Notes
        Where ( 
            Case @SearchField 
                When 'Name' Then [Name] 
                When 'Title' Then Title 
                When 'Content' Then Content 
                Else 
                @SearchQuery 
            End 
        ) Like '%' + @SearchQuery + '%'
    ) 
    Select 
        [Id], [Name], [Email], [Title], [PostDate], 
        [ReadCount], [Ref], [Step], [RefOrder], 
        [AnswerNum], [ParentNum], [CommentCount], 
        [FileName], [FileSize], [DownCount], 
        [RowNumber] 
    From DotNetNoteOrderedLists 
    Where RowNumber Between @Page * 10 + 1 And (@Page + 1) * 10  
    Order By Id Desc
GO
PRINT N'Altering [dbo].[ViewNote]...';


GO
--[3] 해당 글을 세부적으로 읽어오는 저장 프로시저: ViewNote, NotesView
ALTER Procedure dbo.ViewNote
    @Id Int
As
    -- 조회수 카운트 1증가
    Update Notes Set ReadCount = ReadCount + 1 Where Id = @Id
    
    -- 모든 항목 조회
    Select * From Notes Where Id = @Id
GO
PRINT N'Altering [dbo].[WriteNote]...';


GO
--[1] 게시판(DotNetNote)에 글을 작성 : WriteNote
ALTER Proc dbo.WriteNote
    -- 5W1H
    @Name       NVarChar(25), 
    @PostIp     NVarChar(15), 
    @Title      NVarChar(150), 
    @Content    NText, 
	@Category   NVarChar(10), 

    @Email      NVarChar(100), 
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @FileName   NVarChar(255),
    @FileSize   Int
As
    Declare @MaxRef Int
    Select @MaxRef = Max(IsNull(Ref, 0)) From Notes
 
    If @MaxRef Is Null Or @MaxRef = 0
        Set @MaxRef = 1 -- 테이블 생성 후 처음만 비교
    Else
        Set @MaxRef = @MaxRef + 1

    Insert Notes
    (
        Name, Email, Title, PostIp, Content, Password, Encoding, 
        Homepage, Ref, FileName, FileSize,
		Category 
    )
    Values
    (
        @Name, @Email, @Title, @PostIp, @Content, @Password, @Encoding, 
        @Homepage, @MaxRef, @FileName, @FileSize,
		@Category
    )
GO
PRINT N'Creating [dbo].[AddPermission]...';


GO
--[!] 권한 입력 저장 프로시저
Create Proc dbo.AddPermission
    @TID Int, 
    @UID Int, 
    @NoAccess Bit, 
    @List Bit, 
    @ReadArticle Bit, 
    @Download Bit, 
    @Write Bit, 
    @Upload Bit, 
    @Extra Bit, 
    @Admin Bit,
    @Comment Bit
As
    Insert Into Permission (
		TID, UID, NoAccess, List, ReadArticle, Download, Write, Upload, Extra, Admin, Comment
	) 
    Values (
		@TID, @UID, @NoAccess, @List, @ReadArticle, @Download, @Write, @Upload, @Extra, @Admin, @Comment
	)
GO
PRINT N'Creating [dbo].[DeleteSigns]...';


GO
--ModifySigns 'master', '1234', 2


--[5] 삭제 저장 프로시저
Create Proc dbo.DeleteSigns
	@Id Int
As
	Delete Signs Where Id = @Id
GO
PRINT N'Creating [dbo].[GetBlogPost]...';


GO
CREATE PROCEDURE [dbo].[GetBlogPost]
AS
	Begin Transaction -- 의미 없지만, 학습상...
		Select 
			b.Name, b.BloggerName, 
			p.Title, p.Content, p.Created
		From  
			Posts p Join Blogs b 
				On p.BlogId = b.BlogId 
		Order By p.PostId Desc
		
		If @@ERROR > 0 
			RollBack Transaction 
	Commit Transaction
GO
PRINT N'Creating [dbo].[GetLogsWithPaging]...';


GO
CREATE PROCEDURE [dbo].[GetLogsWithPaging]
	@PageIndex int = 0,		-- @PageIndex : 페이지 인덱스 : 0, 1, 2, ...
	@PageSize int = 10		-- @PageSize : 한 페이지에 표시할 레코드 수
AS
	Select 
		[RowNumbers], 
		[Id], 
		[Note], 
		[Application], 
		[Logger], 
		[LogEvent], 
		[Message], 
		[MessageTemplate], 
		[Level], 
		[TimeStamp], 
		[Exception], 
		[Properties], 
		[Callsite], 
		[IpAddress]
	From 
		(
			Select 
				ROW_NUMBER() Over (Order By Id Desc) As RowNumbers, 
				[Id], 
				[Note], 
				[Application], 
				[Logger], 
				[LogEvent], 
				[Message], 
				[MessageTemplate], 
				[Level], 
				[TimeStamp], 
				[Exception], 
				[Properties], 
				[Callsite], 
				[IpAddress] 
			From Logs 
		)
		As TempRowTables
	Where 
		RowNumbers 
			Between 
				(@PageIndex * @PageSize + 1) 
			And 
				(@PageIndex + 1) * @PageSize
GO
PRINT N'Creating [dbo].[GetTableById]...';


GO
CREATE PROCEDURE [dbo].[GetTableById]
	@Id int
AS
	Select [Id], [Note] From Tables Where Id = @Id
GO
PRINT N'Creating [dbo].[GetTables]...';


GO
CREATE PROCEDURE [dbo].[GetTables]
AS
	Select [Id], [Note] From Tables
GO
PRINT N'Creating [dbo].[GetTablesNoteByIdWithOutput]...';


GO
CREATE PROCEDURE [dbo].[GetTablesNoteByIdWithOutput]
	@Id int = 0,
	@Note NVarChar(Max) Output
AS
	Select @Note = Note From Tables Where Id = @Id
GO
PRINT N'Creating [dbo].[GetTablesWithPaging]...';


GO
CREATE PROCEDURE [dbo].[GetTablesWithPaging]
	@PageIndex int = 0,		-- @PageIndex : 페이지 인덱스 : 0, 1, 2, ...
	@PageSize int = 10		-- @PageSize : 한 페이지에 표시할 레코드 수
AS
	Select Id, Note 
	From 
		(
			Select 
				ROW_NUMBER() Over (Order By Id Desc) As RowNumbers, Id, Note 
			From Tables
		)
		As TempRowTables
	Where 
		RowNumbers 
			Between 
				(@PageIndex * @PageSize + 1) 
			And 
				(@PageIndex + 1) * @PageSize
GO
PRINT N'Creating [dbo].[ListSigns]...';


GO
--WriteSigns 'redplus', '1234'


--[2] 출력 저장 프로시저
--Create Proc dbo.ListSigns
--As
--	Select * From Signs Order By Id Desc
--Go
Create Proc dbo.ListSigns
As
	Select [Id], [UserId], [Password] From Signs Order By Id Desc
GO
PRINT N'Creating [dbo].[ModifySigns]...';


GO
--ViewSigns 5


--[4] 수정 저장 프로시저
Create Proc dbo.ModifySigns
	@UserId NVarChar(25),
	@Password NVarChar(20),
	@Id Int
As
	Begin Tran
		Update Signs
		Set	
			UserId = @UserId,
			[Password] = @Password
		Where Id = @Id
	Commit Tran
GO
PRINT N'Creating [dbo].[SearchSigns]...';


GO
--DeleteSigns 2


--[6] 검색 저장 프로시저
Create Proc dbo.SearchSigns
	@SearchField NVarChar(25),
	@SearchQuery NVarChar(25)
As
	Declare @strSql NVarChar(255)
	Set @strSql = '
		Select * From Signs 
		Where 
			' + @SearchField + ' Like ''%' + @SearchQuery + '%''
	'
	-- Print @strSql
	Exec(@strSql)
GO
PRINT N'Creating [dbo].[ViewSigns]...';


GO
--ListSigns


--[3] 상세 저장 프로시저
Create Proc dbo.ViewSigns
	@Id Int
As
	Select [Id], [UserId], [Password] From Signs Where Id = @Id
GO
PRINT N'Creating [dbo].[WriteSigns]...';


GO
--[Sign][0][2] Signs 관련 저장 프로시저 생성

--[1] 입력 저장 프로시저
Create Proc dbo.WriteSigns
	@UserId NVarChar(25),
	@Password NVarChar(20)
As
	Insert Into Signs Values(@UserId, @Password)
GO
PRINT N'Update complete.';


GO
